package two

import (
	"bytes"
	"math"

	log "github.com/sirupsen/logrus"

	"github.com/onyx-and-iris/aoc2024/day-13/internal/util"
)

const augment = 10e12

func Solve(buf []byte) (int, error) {
	r := bytes.NewReader(buf)
	machines, err := util.ParseLines(r)
	if err != nil {
		return 0, err
	}

	var total int
	for _, m := range machines {
		m.Prize.X += augment
		m.Prize.Y += augment

		denominator := m.A.X*m.B.Y - m.B.X*m.A.Y
		a_numerator := m.Prize.X*m.B.Y - m.Prize.Y*m.B.X
		b_numerator := m.Prize.Y*m.A.X - m.Prize.X*m.A.Y

		a := float64(a_numerator) / float64(denominator)
		b := float64(b_numerator) / float64(denominator)

		if a != math.Round(a) || a < 0 || b != math.Round(b) || b < 0 {
			continue
		}

		log.Debug(a, b)

		total += 3*int(a) + int(b)
	}

	return total, nil
}
